"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AltenativesPayload = void 0;
const lodash_1 = __importDefault(require("lodash"));
const base_payload_1 = require("./base-payload");
const utils_1 = require("./utils");
class AltenativesPayload extends base_payload_1.BasePayload {
    constructor() {
        super(...arguments);
        this.alternatives = [];
    }
    getKind() {
        return 'alternatives';
    }
    buildFromSchema(rawSchema) {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any, @typescript-eslint/no-unsafe-assignment
        this.alternatives = rawSchema['$_terms'].matches.map((schema) => utils_1.generatePayload(schema.schema));
        return this;
    }
    generateMock() {
        return this.alternatives[0].generateMock();
    }
    generateAttacks() {
        const attacks = this.alternatives.map(alternativePayload => alternativePayload.generateAttacks());
        return lodash_1.default.flatten(attacks);
    }
}
exports.AltenativesPayload = AltenativesPayload;
